// -------------------------------------------------------------------------------------
// xsEasyCpp
// Demo de Objeto Etiqueta
// g++ -g Etiqueta.cpp -lxseasycpp -LC:/msys64/mingw64/lib -lgtk-3 -lgdk-3 -lz -lgdi32 -limm32 -lshell32 -lole32 -Wl,-luuid -lwinmm -ldwmapi -lsetupapi -lcfgmgr32 -lpangowin32-1.0 -lpangocairo-1.0 -lpango-1.0 -latk-1.0 -lcairo-gobject -lcairo -lgdk_pixbuf-2.0 -lgio-2.0 -lgobject-2.0 -lintl -lglib-2.0 -o Etiqueta.exe
// g++ -g Etiqueta.cpp %PKG-XSEASYCPP% -o Etiqueta.exe
// -------------------------------------------------------------------------------------

// Incluye las librería de xsWindows
#include "include/xsEasyCpp.hpp"


// Detiene el Ciclo Principal iniciado por gtk_main cuando la ventana es destruida
Estatica Vacio fnSalida(xsObjetoGUI* ventana, xsApuntador datos);

// Función para controlar el Cierre de una Ventana
Estatica Entero fnCierre(xsObjetoGUI* ventana, xsEvento *evento);

// Función para controlar la accción del MenuChekItem y Ocultar/Visualizar la Barra de Herramientas
Vacio fnEtiquetaOnOff(xsObjetoGUI* objeto,xsApuntador boton);

// Función principal de xsEasyWindow
xsPrincipal
{
  // Iniciamos xsEasyWindows
  xsAppInicia;

  // Definimos un objeto de la Clase xsVentana
  xsVentana oVentana(XS_CON_CONTENEDOR);

  // Estableciendo un tamaño para la Ventana                                  
  oVentana.colocarDimensiones(400,100);

  // Centrar la Ventana
  oVentana.centrar();

  // Coloca el Título
  oVentana.colocarTitulo("xsEasyCpp Demo Etiqueta");

  // Establece el Icono
  oVentana.colocarIcono("img/js.ico");
    
  // Establece la función de Salida
  oVentana.colocarFuncionSalida(XS_FUNCION_RETORNO (fnSalida));

  // Establece la función de Cierre
  oVentana.colocarFuncionCierre(XS_FUNCION_RETORNO (fnCierre));


  // Creamos la Etiqueta
  xsEtiqueta oEtiqueta("Cerrar Ventana");

  // Indica que tiene ventana para poder controlar click
  oEtiqueta.asignarTieneVentana(VERDAD);
  
  // Coloca el evento de presionar el boton
  oEtiqueta.asignarEvento(XS_BOTON_PRESIONADO_MASCARA);

  // Coloca un tooltip
  oEtiqueta.colocarTextoEmergente("Click para Cerrar Ventana");

  // Agregar la Etiqueta al Contenedor
  oVentana.agregarAlContenedor(oEtiqueta.obtenerManejador());

  // Creamos etiqueta para texto Html
  xsEtiqueta oEtiquetaHtml("");
  oEtiquetaHtml.colocarTextoHtml("La palabra<b>[texto]</b> en negritas");

  // Agregar la Etiqueta al Contenedor
  oVentana.agregarAlContenedor(oEtiquetaHtml.obtenerManejador());

  // Creamos etiqueta para texto Html con secuencias de escape
  xsEtiqueta oEtiquetaHtml2("");
  oEtiquetaHtml2.colocarTextoHtml("El siguiente texto \nen <b><span style=\"italic\">italica y negritas</span></b>");
  oEtiquetaHtml2.alinearHorizontalmente(0.1);

  // Agregar la Etiqueta al Contenedor
  oVentana.agregarAlContenedor(oEtiquetaHtml2.obtenerManejador());

  // Creamos etiqueta con cambio de linea
  xsEtiqueta oEtiquetaCambioLinea("La eLibrary permite generar GUI para \nWindows y Linux");
  oEtiquetaCambioLinea.colocarDimensiones(10,50);
  oEtiquetaCambioLinea.alinearVerticalmente(XS_ALINEACION_FINAL);
  oEtiquetaCambioLinea.justificar(XS_JUSTIFICACION_LLENAR);

  // Agregar la Etiqueta al Contenedor
  oVentana.agregarAlContenedor(oEtiquetaCambioLinea.obtenerManejador());

  // Asocia la función para cerrar la Ventana
  oEtiqueta.conectarSenal("button-press-event",XS_FUNCION_RETORNO (fnSalida),NULO);

  // Muestra todos los objetos
  oVentana.mostrarTodo();

  // Ciclo
  xsAppCiclo;

  // Finaliza retornando 0
  retorna 0;

}


// Detiene el Ciclo Principal iniciado por gtk_main cuando la ventana es destruida
// Puede no ser estática
Estatica Vacio fnSalida(xsObjetoGUI* ventana, xsApuntador datos)
{
	// Mensaje de Salida
	xsImprimir("Saliendo del Sistema (Estatica Vacio)...");

  // Llama a la función de la Librería que sale del Ciclo Main  
  xsAppSalida;
}

// Función para controlar el Cierre de una Ventana
Estatica Entero fnCierre(xsObjetoGUI* ventana, xsEvento *evento)
{
  retorna Falso; // Para que se cierre, lo contrario para que no se cierre
}

// Función para controlar la accción del MenuChekItem y Ocultar/Visualizar la Barra de Herramientas
Vacio fnEtiquetaOnOff(xsObjetoGUI* objeto, xsApuntador boton)
{
  // Verifica si está activo
  si (xsObjeto_MenuOpcionCheck_activo_obtener(XS_CHECK_MENU_OPCION(objeto)))  
       // Mostramos la Barra de Estado
       xsObjeto_mostrar(XS_OBJETOGUI(boton));       
  
  // Está desactiva
  deOtroModo
       // Oculta la Barra
       xsObjeto_ocultar(XS_OBJETOGUI(boton));       
  
}